#include "svc_basic.h"

void svc_basic_roster(thread t, jpacket p, xmlnode query)
{
    session s;
    thread tnew;
    mapi m;

    /* do they want to be anonymous? */
    if(xmlnode_get_tag(query, "password") == NULL)
    {
        /* check the global config to see if we allow anonymous resources */
        return;
    }

    /* create a mapi for auth */
    m = mapi_new(M_PHASE_AUTH, p->p, NULL, p);
    m->auth = M_NONE;
    m->username = xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(query, "username")));
    m->password = xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(query, "password")));
    m->resource = xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(query, "resource")));

    /* see if we please the gods */
    module_dispatch(m);
    if(m->auth == M_AUTH_OK)
    {
        if(resource_lookup(p->from->user, p->from->resource) != NULL)
        {
            /* XXX there's an existing resource, can't have two! throw error */
            return;
        }
        if(!svc_basic_new(t, p->from))
        {
            /* XXX couldn't create a session? */
            return;
        }
    }

    /* XXX auth failed */
}


