#include "jserver.h"

void *server_main(void *arg)
{
    /* thread that handles messages/packets intended for the server
     * - authentication IQ
     * - administration
     * - public IQ (help, reg, etc)
     */
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    
    debug("THREAD:SERVER starting");

    mp = pth_msgport_create("server");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            debug("THREAD:SERVER received a message!");
            /* use module API to handle these or bounce them to the p->from */
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}

