#include "mod_basic.h"

void mod_basic_auth(mapi m)
{
    xmlnode next;

    debug("MOD_BASIC: user[%s] pass[%s]\n",m->username,m->password);

    next = xmlnode_get_firstchild(mod_basic_config);

    while(next != NULL)
    {
        if( xmlnode_get_type(next) == NTYPE_TAG && 
            j_strcmp(xmlnode_get_name(next),"user") == 0 &&
            j_strcmp(m->username, xmlnode_get_attrib(next, "name")) == 0)
        {
            if(j_strcmp(m->password, xmlnode_get_attrib(next, "pass")) == 0)
            {
                m->auth = M_AUTH_OK;
            }else{
                m->auth = M_AUTH_ERROR;
                m->auth_error = pstrdup(m->p, "Basic Authentication Failed");
            }
            return;
        }
        next = xmlnode_get_nextsibling(next);
    }
}

