#include "mod_basic.h"

xmlnode mod_basic_config = NULL;

int dispatch(mapi m)
{
    xmlnode x;
    int ret = M_OK;

    debug("mod_basic");

    switch(m->phase)
    {
        case M_PHASE_CONFIG:
            printf("MOD_BASIC: config %s\n",xmlnode2str(m->pkt->x));
            mod_basic_config = xmlnode_dup(m->pkt->x);
            break;
        case M_PHASE_AUTH:
            printf("MOD_BASIC: auth %s\n",xmlnode2str(m->pkt->x));
            mod_basic_auth(m);
            break;
        default:
            printf("MOD_BASIC: unknown phase %d\n",m->phase);
            ret = M_IGNORE_PHASE;
    }
    return ret;
}

